;===============================================================|
;								|
;		AES for SSE (SIMD)				|
;								|
;				Programmed by			|
;					(S.W.)	( A.Watanabe )	|
;								|
;===============================================================|
;void	__fastcall	AES_SSE_Cipher(char Nr, unsigned char Ks);
;---------------------------------------------------------------|
;*Input								|
;	Nr	Round				(ecx)		|
;	Ks	Pointer of Key schedule		(edx)		|
;	xmm0	Plain text					|
;*Output							|
;	xmm0	Cipher text					|
;*Break								|
;	eax, ecx, edx						|
;	xmm1`7   (all SIMD Register)				|
;===============================================================|
;void	__fastcall	AES_SSE_InvCipher(char Nr, unsigned char Ks);
;---------------------------------------------------------------|
;*Input								|
;	Nr	Round				(ecx)		|
;	Ks	Pointer of Key schedule		(edx)		|
;	xmm0	Cipher text					|
;*Output							|
;	xmm0	Plain text					|
;*Break								|
;	eax, ecx, edx						|
;	xmm1`7   (all SIMD Register)				|
;===============================================================|

.586p
.xmm
.model	flat, stdcall

;****************************************************************
;*		proto type					*
;****************************************************************
;O錾
;printf			proto	near	C	_Format:ptr byte, var:VARARG 

;́AbꑤɂB
RotWord			proto	near	stdcall	data:DWORD
SubWord			proto	near	stdcall	data:DWORD
InvSubWord		proto	near	stdcall	data:DWORD



;vg^Cv錾
AES_SSE_mul		proto	near			;4.2	Multiplication

@AES_SSE_Cipher@8	proto	near	syscall		;5.1	Cipher	(__fastcall)
AES_SSE_SubBytes	proto	near	stdcall		;5.1.1	SubBytes
AES_SSE_ShiftRows	proto	near	stdcall		;5.1.2	ShiftRows
AES_SSE_MixColumns	proto	near	stdcall		;5.1.3	MixColumns
;AES_SSE_AddRoundKey	proto	near	stdcall		;5.1.4	AddRoundKey

@AES_SSE_InvCipher@8	proto	near	syscall		;5.2	InvCipher	(__fastcall)
AES_SSE_InvShiftRows	proto	near	stdcall		;5.2.1	InvShiftRows
AES_SSE_InvSubBytes	proto	near	stdcall		;5.2.2	InvSubBytes
AES_SSE_InvMixColumns	proto	near	stdcall		;5.2.3	InvMixColumns
;AES_SSE_InvAddRoundKey	proto	near	stdcall		;5.2.4	InvAddRoundKey



;****************************************************************
;*		variable					*
;****************************************************************
;ƂAɍ萔BSSE ߗpB
.const
	align(16)

AES_SSE_Mul_Mask1	db	  0,255,  0,255,   0,255,  0,255,   0,255,  0,255,   0,255,  0,255
AES_SSE_Mul_Mask2	db	255,  0,255,  0, 255,  0,255,  0, 255,  0,255,  0, 255,  0,255,  0

AES_SSE_Mask0		db	255,  0,  0,  0, 255,  0,  0,  0, 255,  0,  0,  0, 255,  0,  0,  0
AES_SSE_Mask1		db	  0,255,  0,  0,   0,255,  0,  0,   0,255,  0,  0,   0,255,  0,  0
AES_SSE_Mask2		db	  0,  0,255,  0,   0,  0,255,  0,   0,  0,255,  0,   0,  0,255,  0
AES_SSE_Mask3		db	  0,  0,  0,255,   0,  0,  0,255,   0,  0,  0,255,   0,  0,  0,255

AES_SSE_00FF		dw	00FFh,00FFh,00FFh,00FFh, 00FFh,00FFh,00FFh,00FFh
AES_SSE_011B		dw	011Bh,011Bh,011Bh,011Bh, 011Bh,011Bh,011Bh,011Bh

;===============================================================|
;	fips-197	4.2	Multiplication			|
;---------------------------------------------------------------|
;								|
;		xmm0		vZO	ij󂹂j		|
;		al		鐔i0`15j		|
;								|
;		xmm1		vZ				|
;	gp郌WX^	xmm4`xmm7			|
;		ecx		Zp				|
;		xmm1		vZʁiBytesj		|
;		xmm5		vZʁiBytesj		|
;		xmm4		Zl				|
;		xmm6		Zl				|
;		xmm7		rp				|
;===============================================================|
.code
	align(16)
AES_SSE_mul	proc

	movdqa	xmm6, xmm0
	pxor	xmm1, xmm1
	pand	xmm6, XMMWORD PTR [AES_SSE_Mul_Mask1]
	psrlw	xmm6, 8

	movdqa	xmm4, xmm0
	pxor	xmm5, xmm5
	pand	xmm4, XMMWORD PTR [AES_SSE_Mul_Mask2]

	xor	ecx, ecx
	mov	cl, 008h		;000h ` 00Fh ͈̔͂łgȂB

	align(16)
	.repeat
		psllw	xmm1, 1			;result <<= 1;
		movdqa	xmm7, xmm1
		pcmpgtw	xmm7, XMMWORD PTR [AES_SSE_00FF]
		pand	xmm7, XMMWORD PTR [AES_SSE_011B]
		pxor	xmm1, xmm7		;result ^= ((result & 0x100)?	0x11B	: 0);

		psllw	xmm5, 1			;result <<= 1;
		movdqa	xmm7, xmm5
		pcmpgtw	xmm7, XMMWORD PTR [AES_SSE_00FF]
		pand	xmm7, XMMWORD PTR [AES_SSE_011B]
		pxor	xmm5, xmm7		;result ^= ((result & 0x100)?	0x11B	: 0);
		.if	(al & cl)
			pxor	xmm1,	xmm6
			pxor	xmm5,	xmm4
		.endif
		shr	cl, 1
	.until	(!cl)

	psllw	xmm1, 8
	por	xmm1, xmm5

	ret

AES_SSE_mul	endp
;===============================================================|
;	fips-197	5.1	Cipher				|
;---------------------------------------------------------------|
;								|
;		xmm0		Plain Text			|
;		ecx	Nr	Round				|
;		edx	ptrKS	Pointer of Key stream		|
;	Ԓl							|
;		xmm0		Cipher Text			|
;===============================================================|
.code
	align(16)
@AES_SSE_Cipher@8	proc	SYSCALL	uses	ebx edi esi

	movzx	edi, cl
	mov	esi, edx
	xor	ebx, ebx
	shl	edi, 4

	;=======================
	;Round (0)
	;---------------
	;AddRoundKey()
	pxor	xmm0, XMMWORD PTR [esi + ebx]
	add	ebx, 16

	;=======================
	;Round (1) ` (Nr-1)
	align(16)
	.repeat
		invoke	AES_SSE_SubBytes
		invoke	AES_SSE_ShiftRows
		invoke	AES_SSE_MixColumns
		pxor	xmm0, XMMWORD PTR [esi + ebx]
		add	ebx, 16
	.until	(edi <= ebx)

	;=======================
	;Last Round (Nr)
	invoke	AES_SSE_SubBytes
	invoke	AES_SSE_ShiftRows
	pxor	xmm0, XMMWORD PTR [esi + ebx]

	ret
@AES_SSE_Cipher@8	endp
;===============================================================|
;	fips-197	5.1.1	SubBytes			|
;---------------------------------------------------------------|
;								|
;		xmm0	input					|
;	Ԓl							|
;		xmm0	output					|
;===============================================================|
	align(16)
AES_SSE_SubBytes	proc

	push	ebx
	lea	ebx, [esp - 16]
	sub	esp, 32
	and	ebx, -16	;align(16)

	movdqa	XMMWORD PTR [ebx], xmm0
	invoke	SubWord, DWORD PTR [ebx + 0]
	mov	DWORD PTR [ebx + 0], eax
	invoke	SubWord, DWORD PTR [ebx + 4]
	mov	DWORD PTR [ebx + 4], eax
	invoke	SubWord, DWORD PTR [ebx + 8]
	mov	DWORD PTR [ebx + 8], eax
	invoke	SubWord, DWORD PTR [ebx + 12]
	mov	DWORD PTR [ebx + 12], eax
	movdqa	xmm0, XMMWORD PTR [ebx]

	add	esp, 32
	pop	ebx
	ret
AES_SSE_SubBytes	endp
;===============================================================|
;	fips-197	5.1.2	ShiftRows			|
;---------------------------------------------------------------|
;								|
;		xmm0	input					|
;	Ԓl							|
;		xmm0	output					|
;===============================================================|
	align(16)
AES_SSE_ShiftRows	proc

					;[0] 0,1,2,3
	pshufd	xmm1, xmm0, 00111001b	;[1] 1,2,3,0
	pshufd	xmm2, xmm0, 01001110b	;[2] 2,3,0,1
	pand	xmm1, XMMWORD PTR [AES_SSE_Mask1]
	pand	xmm2, XMMWORD PTR [AES_SSE_Mask2]
	pshufd	xmm3, xmm0, 10010011b	;[3] 3,0,1,2
	pand	xmm0, XMMWORD PTR [AES_SSE_Mask0]
	pand	xmm3, XMMWORD PTR [AES_SSE_Mask3]
	por	xmm2, xmm3
	por	xmm0, xmm1
	por	xmm0, xmm2

	ret
AES_SSE_ShiftRows	endp
;===============================================================|
;	fips-197	5.1.3	MixColumns			|
;---------------------------------------------------------------|
;								|
;		xmm0	input					|
;	Ԓl							|
;		xmm0	output					|
;===============================================================|
	align(16)
AES_SSE_MixColumns	proc

	;---------------
	;Z	
	;āAXORB
	;   |	2S0	2S1	2S2	2S3	|
	;   |	 S3	 S0	 S1	 S2	|
	;   |	 S2	 S3	 S0	 S1	|
	;   |	3S1	3S2	3S3	3S0	|

	mov	al, 2
	invoke	AES_SSE_mul		;//NX̃o[֐Ȃ̂ŁA ֐Kthiscall
	movdqa	xmm2, xmm1		;//ꎞۑ

	mov	al, 3
	invoke	AES_SSE_mul		;//NX̃o[֐Ȃ̂ŁA ֐Kthiscall
	movdqa	xmm3, xmm1
	psrld	xmm1, 8
	pslld	xmm3, 24
	por	xmm1, xmm3
	pxor	xmm1, xmm2

	movdqa	xmm3, xmm0
	movdqa	xmm2, xmm0
	pslld	xmm3, 16
	psrld	xmm2, 16
	por	xmm2, xmm3

	movdqa	xmm3, xmm0
	psrld	xmm0, 24
	pslld	xmm3, 8
	pxor	xmm1, xmm2
	por	xmm0, xmm3
	pxor	xmm0, xmm1

	ret
AES_SSE_MixColumns	endp
;===============================================================|
;	fips-197	5.2	InvCipher			|
;---------------------------------------------------------------|
;								|
;		xmm0		Cipher Text			|
;		ecx	Nr	Round				|
;		edx	ptrKS	Pointer of Key stream		|
;	Ԓl							|
;		xmm0		Plain Text			|
;===============================================================|
.code
	align(16)
@AES_SSE_InvCipher@8	proc	SYSCALL	uses	ebx edi esi

	movzx	ebx, cl
	shl	ebx, 4
	mov	esi, edx

	;=======================
	;Round (Nr)
	pxor	xmm0, XMMWORD PTR [esi + ebx]
	sub	ebx, 16

	;=======================
	;Round (Nr-1) ` (1)
	align(16)
	.repeat
		invoke	AES_SSE_InvShiftRows
		invoke	AES_SSE_InvSubBytes
		pxor	xmm0, XMMWORD PTR [esi + ebx]
		invoke	AES_SSE_InvMixColumns
		sub	ebx, 16
	.until(zero?)

	;=======================
	;Round (0)
	invoke	AES_SSE_InvShiftRows
	invoke	AES_SSE_InvSubBytes
	pxor	xmm0, XMMWORD PTR [esi + ebx]

	ret
@AES_SSE_InvCipher@8	endp
;===============================================================|
;	fips-197	5.2.1	ShiftRows			|
;---------------------------------------------------------------|
;								|
;		xmm0	input					|
;	Ԓl							|
;		xmm0	output					|
;===============================================================|
	align(16)
AES_SSE_InvShiftRows	proc

					;[0] 0,1,2,3
	pshufd	xmm1, xmm0, 00111001b	;[1] 1,2,3,0
	pshufd	xmm2, xmm0, 01001110b	;[2] 2,3,0,1
	pand	xmm1, XMMWORD PTR [AES_SSE_Mask3]
	pand	xmm2, XMMWORD PTR [AES_SSE_Mask2]
	pshufd	xmm3, xmm0, 10010011b	;[3] 3,0,1,2
	pand	xmm0, XMMWORD PTR [AES_SSE_Mask0]
	pand	xmm3, XMMWORD PTR [AES_SSE_Mask1]
	por	xmm2, xmm3
	por	xmm0, xmm1
	por	xmm0, xmm2

	ret
AES_SSE_InvShiftRows	endp
;===============================================================|
;	fips-197	5.2.2	InvSubBytes			|
;---------------------------------------------------------------|
;								|
;		xmm0	input					|
;	Ԓl							|
;		xmm0	output					|
;===============================================================|
	align(16)
AES_SSE_InvSubBytes	proc

	push	ebx

	lea	ebx, [esp - 16]
	sub	esp, 32
	and	ebx, -16	;align(16)

	movdqa	XMMWORD PTR [ebx], xmm0
	invoke	InvSubWord, DWORD PTR [ebx + 0]
	mov	DWORD PTR [ebx + 0], eax
	invoke	InvSubWord, DWORD PTR [ebx + 4]
	mov	DWORD PTR [ebx + 4], eax
	invoke	InvSubWord, DWORD PTR [ebx + 8]
	mov	DWORD PTR [ebx + 8], eax
	invoke	InvSubWord, DWORD PTR [ebx + 12]
	mov	DWORD PTR [ebx + 12], eax
	movdqa	xmm0, XMMWORD PTR [ebx]

	add	esp, 32

	pop	ebx
	ret
AES_SSE_InvSubBytes	endp
;===============================================================|
;	fips-197	5.1.3	MixColumns			|
;---------------------------------------------------------------|
;								|
;		xmm0	input					|
;	Ԓl							|
;		xmm0	output					|
;===============================================================|
	align(16)
AES_SSE_InvMixColumns	proc

	;---------------
	;Z	
	;āAXORB
	;  = |	e.S0	e.S1	e.S2	e.S3	|
	;  = |	9.S3	9.S0	9.S1	9.S2	|
	;  = |	d.S2	d.S3	d.S0	d.S1	|
	;  = |	b.S1	b.S2	b.S3	b.S0	|

	;AES_SSE_mul
	;	xmm2,3,4 ͔j󂹂B

	mov	al, 00Eh
	invoke	AES_SSE_mul		;//NX̃o[֐Ȃ̂ŁA ֐Kthiscall
	movdqa	xmm2, xmm1		;//[0]

	mov	al, 009h
	invoke	AES_SSE_mul		;//NX̃o[֐Ȃ̂ŁA ֐Kthiscall
	movdqa	xmm3, xmm1
	pslld	xmm1, 8
	psrld	xmm3, 24		;//[1]
	por	xmm3, xmm1
	pxor	xmm2, xmm3

	mov	al, 00Dh
	invoke	AES_SSE_mul		;//NX̃o[֐Ȃ̂ŁA ֐Kthiscall
	movdqa	xmm3, xmm1
	pslld	xmm1, 16
	psrld	xmm3, 16		;//[2]
	por	xmm3, xmm1

	mov	al, 00Bh
	invoke	AES_SSE_mul		;//NX̃o[֐Ȃ̂ŁA ֐Kthiscall
	movdqa	xmm0, xmm1
	pslld	xmm1, 24
	psrld	xmm0, 8
	por	xmm0, xmm1		;//[3]
	pxor	xmm0, xmm3
	pxor	xmm0, xmm2

	ret
AES_SSE_InvMixColumns	endp
;****************************************************************
	end
